Table layout breaks due to .icon class on td elements
2024-11-26 01:55 - Mizuki ISHIKAWA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 6.0.2

Resolution: Fixed Affected version:

Description

The table layout is breaking because td elements have the .icon class applied to them. When the .icon class is used, its display:
inline-flex; style is applied, which disrupts the table layout.

This issue is particularly noticeable in themes with table borders, such as the Alternate theme, where the layout break becomes
visually evident.

The attached patch modifies the structure by inserting a span element inside the td element and applying the .icon class to the span.
This ensures that the table layout remains intact.

Affected Areas: ( Use Alternate theme )

e Versions" tab in the project settings
screenshot 2024-11-26 9.49.46.png

e forum pages (boards/show)
screenshot 2024-11-26 9.49.57.png

Associated revisions

Revision 23317 - 2024-11-28 10:01 - Go MAEDA

Table layout breaks due to .icon class on td elements (#41873).

Patch by Mizuki ISHIKAWA (user:ishikawa999) and Katsuya HIDAKA (user:hidakatsuya).

Revision 23334 - 2024-11-30 08:01 - Go MAEDA
Merged r23317 from trunk to 6.0-stable (#41873).

Revision 23348 - 2024-12-03 09:18 - Go MAEDA

Fix misaligned icons and inconsistent indentation in forum message lists (#41873).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

Revision 23349 - 2024-12-03 09:19 - Go MAEDA
Merged r23348 from trunk to 6.0-stable (#41873).

History

#1 - 2024-11-26 03:37 - Go MAEDA

- Tracker changed from Patch to Defect
- Category set to Ul

- Status changed from New to Confirmed

- Target version set to 6.0.2

#2 - 2024-11-27 08:58 - Katsuya HIDAKA
- File version-setings-before-fix.png added
- File version-settings-after-fix.png added

- File fix-td-layout-shared-version-padding.diff added

| tested the patch and found that the layout of the Versions settings table is broken. An unnecessary padding is added to the left of the shared version
names from other projects.

version-setings-before-fix.png

This issue occurs because the following style is incorrectly applied by the attached patch.

https://github.com/redmine/redmine/blob/1612d85ad808c36d7315c75cad1e4bdfbbb9db62/app/assets/stylesheets/application.css#L431

tr.version td.name:not (.icon-shared) {
To fix this, the following change resolves the issue:

tr.version.closed, tr.version.closed
—tr.version td.name:not (.icon-shared)

padding-left: 20px; }

a { color: #999; }
{ padding-left: 20px; }

+tr.version td.name:not (:has(.icon-shared)) { padding-left: 20px; }

tr.version td.date, tr.version td.status,

However, since the .icon-shared class is no longer needed, | updated the patch to rely on the .shared class applied to <tr class="version shared">

tags instead. | have attached the updated patch as

Additionally, | removed the unnecessary .icon-sticky and .icon-locked classes from the forums page, as they are also no longer required. These

changes are included in the attached patch.
Below is the corrected Versions settings table after
version-settings-after-fix.png

#3 - 2024-11-28 07:21 - Mizuki ISHIKAWA
Katsuya HIDAKA

"fix-td-layout-shared-version-padding.diff".

applying the updated patch:

Thank you. | have confirmed that the patch seems to work well.

#4 - 2024-11-28 10:02 - Go MAEDA
- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23317. Thank you.

#5 - 2024-11-30 08:02 - Go MAEDA

- Status changed from Resolved to Closed

Merged the fix into the 6.0-stable branch in r23334.

#6 - 2024-12-03 05:44 - Mizuki ISHIKAWA

- File screenshot 2024-12-03 13.39.34.png added
- File screenshot 2024-12-03 13.40.38.png added
- File screenshot 2024-12-03 13.41.38.png added

The position of the links on the forum page was shifted due to the change applied in this issue.

Please apply the following fix:

diff --git a/app/assets/stylesheets/application.css b/app/assets/stylesheets/application.css

index 1c9595172..81182b2ce 100644

-—— a/app/assets/stylesheets/application.css
+++ b/app/assets/stylesheets/application.css
@@ -422,6 +422,7 Q@ tr.message { height: 2.6em; }
tr.message td.created_on { white-space: nowrap; }

tr.message td.last_message { font-size: 93%; white-space: nowrap; }
tr.message.sticky td.subject { font-weight: bold; }

+tr.message:not (.sticky) :not (.locked)

td.subject { padding-left: 20px;

body.avatars—-on #replies .message.reply {padding-left: 32px;}
#replies .reply:target h4.reply-header {background-color:#DDEEFF; }

tr.version td.sharing { text-align:

}

center; white-space:nowrap;

}

Before this issue's change

After this issue's change

After applying this fix
https://github.com/redmine/redmine/blob/1612d85ad808c36d7315c75cad1e4bdfbbb9db62/app/assets/stylesheets/application.css#L431
https://www.redmine.org/users/37224
https://www.redmine.org/projects/redmine/repository/svn/revisions/23317
https://www.redmine.org/projects/redmine/repository/svn/revisions/23334

screenshot 2024-12-03 13.41.38.png screenshot 2024-12-03 13.40.38.png screenshot 2024-12-03 13.39.34.png

#7 - 2024-12-03 05:52 - Mizuki ISHIKAWA

The following modification might make the intention clearer than the diff provided in #note-6:

diff --git a/app/assets/stylesheets/application.css b/app/assets/stylesheets/application.css
index 1c¢9595172..89d385cal0 100644

-—— a/app/assets/stylesheets/application.css

+++ b/app/assets/stylesheets/application.css

@@ -422,6 +422,7 Q@ tr.message { height: 2.6em; }

tr.message td.created_on { white-space: nowrap; }

tr.message td.last_message { font-size: 93%; white-space: nowrap; }
tr.message.sticky td.subject { font-weight: bold; }
+tr.message td.subject:not(:has(.icon)) { padding-left: 20px; }

body.avatars-on #replies .message.reply {padding-left: 32px;}
#replies .reply:target hd4.reply-header {background-color:#DDEEFF; }

#8 - 2024-12-03 06:28 - Katsuya HIDAKA

- File result-when-the-subject-is-long.png added

Thank you for providing the fix. | reviewed the #note-7 patch and tested the following cases:

When the sticky icon is present.

When the lock icon is present.

When no icons are present.

When the subject is long (see attached screenshot).

Tested in Chrome, Safari, and Firefox. Everything works as expected.

#9 - 2024-12-03 09:21 - Go MAEDA
Committed the #note-7 in r23348 and merged it into 6.0-stable in r23349. Thank you.
